#!/bin/bash
# set -e

self_="$(readlink -f "$0")"
cmd_="../otsplit"

make
mkdir -p test
cd test

rm -f foo.*
"$cmd_" -s foo.{1..7} < "$self_"
"$cmd_" -j foo.* > copy.txt
if ! diff -q "$self_" copy.txt
then
  echo "error: random split failed"
  exit 1
else
  echo "random split succeeded"
fi
rm foo.*

dd if=/dev/urandom of=pad bs=1M count=5 2>/dev/null

rm -f foo
"$cmd_" -s -p pad foo < "$self_"
"$cmd_" -j -p pad foo > copy.txt
if ! diff -q "$self_" copy.txt
then
  echo "error: pre-existing pad split failed"
  exit 1
else
  echo "pre-existing pad split succeeded"
fi
rm foo

"$cmd_" -s -p pad - < "$self_" | "$cmd_" -j - pad > copy.txt
if ! diff -q "$self_" copy.txt
then
  echo "error: piping failed"
  exit 1
else
  echo "piping succeeded"
fi

"$cmd_" -s -o 15678 -p pad - < "$self_" | "$cmd_" -j -o 15678 - pad > copy.txt
if ! diff -q "$self_" copy.txt
then
  echo "error: offset failed"
  exit 1
else
  echo "offset succeeded"
fi

"$cmd_" -s -r /dev/zero foo.{1..2} < "$self_"
"$cmd_" -j foo.* > copy.txt
if ! diff -q "$self_" copy.txt
then
  echo "error: input source option failed"
  exit 1
else
  echo "input source option succeeded"
fi
rm foo.*



# cd --
echo "all tests passed"
exit 0
